#!/usr/bin/env python2.5
# -*- coding: utf-8 -*-

# copyright: m. dietrich
# license: gpl
__revision = '$Rev: 218 $'

from dbus import SystemBus, Interface
from dbus.mainloop.glib import DBusGMainLoop
from gobject import MainLoop
from os import system # alsactl is used with a sytem call
from base import dedbusmap
from freesmartphone import *

def DeviceInfo(newmap):
	newmap = dedbusmap(newmap)
	print 'DeviceInfo', newmap
	# manufacturer: manufacturer of the modem

	# model: model of the modem

	# revision: version of the modem hw

	# imei: uniq serial identifier of the hw

def SimAuthStatus(newmap):
	newmap = dedbusmap(newmap)
	print 'SimAuthStatus', newmap
	global pin_given_once, registered_once, gsm_interface, pin_state, network_stat
	pin_state = newmap['pin_state']
	# pin_state:
	# 	"READY" ME is not pending for any password
	# 	"SIM PIN" ME is waiting SIM PIN to be given
	# 	"SIM PUK" ME is waiting SIM PUK to be given;
	# 	"PH-SIM PIN" ME is waiting phone-to-SIM card password to be given;
	# 	"PH-FSIM PIN" ME is waiting phone-to-very first SIM card password to be
	# 		given
	# 	"PH-FSIM PUK" ME is waiting phone-to-very first SIM card unblocking
	# 		password to be given
	# 	"SIM PIN2" ME is waiting SIM PIN2 to be given (this <code> is
	# 		recommended to be returned only when the "SIM PUK2" last executed
	# 		command resulted in PIN2 authentication failure (i.e. +CME ERROR:
	# 		17) if PIN2 is not entered right after the failure, it is
	# 		recommended that ME does not block its operation) ME is waiting SIM
	# 		PUK2 to be given (this <code> is recommended to be returned only
	# 		when the;
	# 	"PH-NET PIN" last executed command resulted in PUK2 authentication
	# 		failure (i.e. +CME ERROR: 18) if PUK2 and new PIN2 are not entered
	# 		right after the failure, it is recommended that ME does not block
	# 		its operation) ME is waiting network personalisation password to be
	# 		given;
	# 	"PH-NET PUK" ME is waiting network personalisation unblocking password
	# 		to be given
	# 	"PH-NETSUB PIN" ME is waiting network subset personalisation password
	# 		to be given
	# 	"PH-NETSUB PUK" ME is waiting network subset personalisation unblocking
	# 		password to be given
	# 	"PH-SP PIN" ME is waiting service provider personalisation password to
	# 		be given
	# 	"PH-SP PUK" ME is waiting service provider personalisation unblocking
	# 		password to be given
	# 	"PH-CORP PIN" ME is waiting corporate personalisation password to be
	# 		given
	# 	"PH-CORP PUK" ME is waiting corporate personalisation unblocking
	# 		password to be given
	if pin_state == 'SIM PIN':
		print 'pin required'
		if not pin_given_once:
			pin_given_once = True
			gsm_interface.SimSendAuthCode('2222')
			print 'sending pin'
	elif pin_state == 'READY':
		print 'pin accepted'

def NetworkStatus(newmap):
	newmap = dedbusmap(newmap)
	print 'NetworkStatus', newmap
	global pin_given_once, registered_once, gsm_interface, pin_state, network_stat
	network_stat = int(newmap.get('stat', 0))
	# network_stat:
	# 	0	not registered, ME is not currently searching a new operator to
	# 		register to
	# 	1	registered, home network
	# 	2	not registered, but ME is currently searching a new operator to
	# 		register to
	# 	3	registration denied
	# 	4	unknown
	# 	5	registered, roaming;
	if network_stat in (1, 5, ):
		print 'registered'
	else:
		if not registered_once:
			registered_once = True
			gsm_interface.NetworkRegister()
			print 'sending register'
	# wireless_selected_46:
	# 	12	GSM digital cellular

	# phone_activity_status:
	# 	0	ready (ME allows commands from TA/TE)
	# 	1	unavailable (ME does not allow commands from TA/TE)
	# 	2	unknown (ME is not guaranteed to respond to instructions)
	# 	3	ringing (ME is ready for commands from TA/TE, but the ringer is
	# 		active)
	# 	4	call in progress (ME is ready for commands from TA/TE, but a call
	# 		is in progress)
	# 	5	asleep (ME is unable to process commands from TA/TE because it is
	# 		in a low functionality state);

	phone_activity_status = int(newmap.get('phone_activity_status', 1))
	if phone_activity_status == 3:
		system('alsactl -f /etc/gsmhandset.state restore')
		gsm_interface.CallAccept()

	# function:
	# 	0 minimum functionality
	# 	1 full functionality
	# 	2 disable phone transmit RF circuits only
	# 	3 disable phone receive RF circuits only
	# 	4 disable phone both transmit and receive RF circuits;

	# operator_selection_mode:
	# 	0 automatic
	# 	1 manual
	# 	2 deregister from network 

	# rssi:
	# 	0 -113 dBm or less
	# 	1 -111 dBm
	# 	2...30 -109... -53 dBm
	# 	31 -51 dBm or greater
	# 	99 not known or not detectable;

	# ber (in percent):
	# 	0...7  as RXQUAL values in the table in GSM 05.08 [20] subclause 8.2.4
	# 	99 not known or not detectable;

def error(list):
	list = [str(l) for l in list]
	print 'error', list

DBusGMainLoop(set_as_default=True)
bus = SystemBus()

def ign(*data):
	print 'ign', data

gsm_obj = bus.get_object(DBUS_NAME, '/org/mobile/GsmPhone')
for fkt in (DeviceInfo, SimAuthStatus, NetworkStatus, error, ):
	gsm_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=DIN_PHONE)
gsm_interface = Interface(gsm_obj, DIN_PHONE)
gsm_interface.DeviceGetInfo(reply_handler=DeviceInfo, error_handler=ign, )
gsm_interface.SimGetAuthStatus(reply_handler=SimAuthStatus, error_handler=ign, )
gsm_interface.NetworkGetStatus(reply_handler=NetworkStatus, error_handler=ign, )
pin_state = "UNKOWN"
network_stat = 0
registered_once = pin_given_once = False

mainloop = MainLoop()
try:
	mainloop.run()
finally:
	pass#gsm.power(False)
# vim:tw=0:nowrap
