#!/usr/bin/env python2.5
# -*- coding: utf-8 -*-

# copyright: m. dietrich
# license: gpl
__revision = '$Rev: 252 $'

from os import unlink
from thread import start_new_thread
from Queue import Queue
from struct import pack, unpack, calcsize
from gdbm import open as db_open
from base import log_info, log_debug, config, LOG_ERR, LOG_WARNING, LOG_INFO, LOG_DEBUG, LOG, dedbusmap
from freesmartphone import *

'''
DB="dbus-send --system --print-reply --type=method_call --dest=org.mobile /org/mobile/OpenStreetMap"
$DB org.mobile.Map.RequestMap int32:10 int32:529 int32:338
'''

class OpenStreetMap(NotifyObject):
	def __init__(self, bus):
		LOG(LOG_DEBUG, __name__, '__init__')
		NotifyObject.__init__(self,
			object_path='/org/mobile/OpenStreetMap',
			bus_name=BusName(DBUS_NAME, bus),
			)
		self.queue = Queue(100)
		self.cachedir = config.get('osm', 'cachedir')
		start_new_thread(self.waiter, ())

	@method(DIN_MAP, 'iii', '')
	def RequestMap(self, x, y, zoom):
		LOG(LOG_DEBUG, __name__, 'RequestMap', x, y, zoom)
		self.queue.put((x, y, zoom, ))

	@notify(DIN_MAP, 'a{sv}')
	def NewFile(self, content):
		LOG(LOG_DEBUG, __name__, 'Position', content)

	def waiter(self):
		while True:
			x, y, zoom = self.queue.pop()
			self.download(x, y, zoom)

	def download(self, x, y, zoom):
		filename = "%d/%d/%d.png"%(zoom, x, y)
		LOG(LOG_DEBUG, __name__, 'download', filename)
		try:
			dirname = "%d/%d"%(zoom, x)
			if not os.path.exists(dirname):
				os.makedirs(dirname)
			localFile = open(filename, 'w')
			webFile = self.opener.open("http://a.tile.openstreetmap.org/%d/%d/%d.png"%(zoom, x, y))
			localFile.write(webFile.read())
			webFile.close()
			localFile.close()
		except Exception, e:
			LOG(LOG_ERR, __name__, 'download', filename)
			if os.path.exists(filename):
				os.unlink(filename)


if __name__ == '__main__':
	from syslog import openlog, syslog, closelog, LOG_ERR, LOG_WARNING, LOG_INFO, LOG_DEBUG, LOG_DAEMON, LOG_NDELAY, LOG_PID, LOG_PERROR
	from gobject import MainLoop
	from dbus.mainloop.glib import DBusGMainLoop
	openlog('pyggld', LOG_NDELAY|LOG_PID|LOG_PERROR, LOG_DAEMON,)
	DBusGMainLoop(set_as_default=True)
	mainloop = MainLoop()
	daemon = OpenStreetMap(InitBus())
	mainloop.run()
	closelog()
# vim:tw=0:nowrap
