#!/usr/bin/env python2.5
# -*- coding: iso8859-15 -*-

# copyright: m. dietrich
# license: gpl
__revision = '$Rev: 93 $'

import ecore
import ecore.evas
import edje
import sys
from os.path import exists
from dbus import SystemBus, Interface
from e_dbus import DBusEcoreMainLoop
from datetime import datetime
from os import system # alsactl is used with a sytem call

def ign(*data):
	print 'ign', data

def dedbusmap(map):
	ret = {}
	for n, v in map.items():
		ret[n.encode('ascii')] = unicode(v)
	return ret

pypwrd_hook = None
def usb_alert(plugged):
	print 'usb_alert', plugged
	pypwrd_hook.get_status()
	return False

class Things(object):
	visible_things = []
	invisible_things = []
	active_thing = 0
	foreground = None
	animate_timer = None
	@classmethod
	def init(clazz, ee):
		if not clazz.foreground:
			clazz.foreground = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group='foreground')
			clazz.foreground.size = ee.evas.size
			clazz.foreground.show()
			clazz.foreground.focus = True
			clazz.foreground.on_key_up_add(clazz.on_key_up)
			clazz.foreground.on_key_down_add(clazz.on_key_down)
			#clazz.foreground.signal_callback_add('mouse,up,1', '*', clazz.on_mouse_up)
			clazz.foreground.signal_callback_add("mouse,down,1", "*", clazz.on_mouse_down)
			clazz.animate_timer = ecore.timer_add(0.08, clazz.animate)
			ee.data['things'] = clazz
			clazz.source = None
	@classmethod
	def animate(clazz, ):
		ret = False
		for thing in clazz.invisible_things:
			if not thing.animate():
				clazz.invisible_things.remove(thing)
		for thing in clazz.visible_things:
			ret = thing.animate() or ret
		clazz.animate_timer = None
		return ret
	@classmethod
	def on_key_down(clazz, foreground, event):
		if event.keyname == 'Mode_switch': # USB
			ecore.timer_add(1, usb_alert, True)
	@classmethod
	def on_key_up(clazz, foreground, event):
		if event.keyname == 'Mode_switch': # USB
			ecore.timer_add(1, usb_alert, False)
		elif event.keyname == 'Keycode-177': # Aux
			if detail_view:
				detail_view.yes()
			elif clazz.active_thing >= 0 and clazz.active_thing < len(clazz.visible_things):
				if clazz.visible_things[clazz.active_thing].yes():
					clazz.remove(clazz.visible_things[clazz.active_thing])
		#elif event.keyname == 'Execute': # Power
		else:
			print 'on_key_up', event
	#@classmethod
	#def on_mouse_up(clazz, foreground, signal, source):
	@classmethod
	def on_mouse_down(clazz, foreground, signal, source):
		assert not detail_view
		if source == 'up':
			if clazz.active_thing > 0:
				clazz.active_thing -= 1
				for n, thing in enumerate(clazz.visible_things):
					thing.set_screenpos(n - clazz.active_thing + 1, n==clazz.active_thing)
				if not clazz.animate_timer: clazz.animate_timer = ecore.timer_add(0.08, clazz.animate)
		elif source == 'down':
			if clazz.active_thing+1 < len(clazz.visible_things):
				clazz.active_thing += 1
				for n, thing in enumerate(clazz.visible_things):
					thing.set_screenpos(n - clazz.active_thing + 1, n==clazz.active_thing)
				if not clazz.animate_timer: clazz.animate_timer = ecore.timer_add(0.08, clazz.animate)
		elif source == 'yes' or source == 'select':
			if clazz.active_thing >= 0 and clazz.active_thing < len(clazz.visible_things):
				if clazz.visible_things[clazz.active_thing].yes():
					clazz.remove(clazz.visible_things[clazz.active_thing])
		elif source == 'no':
			if clazz.active_thing >= 0 and clazz.active_thing < len(clazz.visible_things):
				if clazz.visible_things[clazz.active_thing].no():
					clazz.remove(clazz.visible_things[clazz.active_thing])
		elif source == 'maybe':
			if clazz.active_thing >= 0 and clazz.active_thing < len(clazz.visible_things):
				if clazz.visible_things[clazz.active_thing].maybe():
					clazz.remove(clazz.visible_things[clazz.active_thing])
		else:
			print 'on_mouse_down', foreground, signal, source
	@classmethod
	def new(clazz, thing, active_thing=0):
		if thing in clazz.invisible_things:
			clazz.invisible_things.remove(thing)
		if thing in clazz.visible_things:
			return
		if not detail_view:
			clazz.active_thing = active_thing
		else:
			clazz.active_thing += 1
		clazz.visible_things.insert(active_thing, thing)
		clazz.foreground.raise_()
		if detail_view:
			detail_view.part.raise_()
		for n, thing in enumerate(clazz.visible_things):
			thing.set_screenpos(n - clazz.active_thing + 1, n==clazz.active_thing)
		if not clazz.animate_timer: clazz.animate_timer = ecore.timer_add(0.08, clazz.animate)
	@classmethod
	def is_visible(clazz, thing):
		return thing in clazz.visible_things
	@classmethod
	def remove(clazz, thing):
		idx = clazz.visible_things.index(thing)
		thing = clazz.visible_things.pop(idx)
		thing.setpointx = thing.part.rect.w # TODO: where to get the screenwidth
		thing.active = False
		thing.part.color = (128, 128, 128, 128, ) # TODO workaround for missing method
		clazz.invisible_things.append(thing)
		if clazz.active_thing >= len(clazz.visible_things):
			clazz.active_thing -= 1
		for n, thing in enumerate(clazz.visible_things):
			thing.set_screenpos(n - clazz.active_thing + 1, n==clazz.active_thing)
		if not clazz.animate_timer: clazz.animate_timer = ecore.timer_add(0.08, clazz.animate)

detail_view = None
class Detail(object):
	def __init__(self, ee, callback, group):
		global detail_view
		assert detail_view is None
		self.ee = ee
		self.callback = callback
		self.part = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group=group)
		self.part.signal_callback_add("mouse,down,1", "*", self.on_mouse_down)
		self.part.show()
	def yes(self):
		self.delete()
		return self.callback(True)
	def no(self):
		self.delete()
		return self.callback(False)
	def maybe(self):
		self.delete()
		return self.callback(None)
	def delete(self):
		self.part.delete()
		del self.part
		global detail_view
		detail_view = None
	def on_mouse_down(self, edje_obj, emission, source):
		getattr(self, source)()

class TextDetail(Detail):
	def __init__(self, ee, text, callback):
		Detail.__init__(self, ee, callback, 'detail')
		self.part.part_text_set('text', text)

class Numpad(Detail):
	digits = {
		"0": u"0+",
		"1": u"1",
		"2": u"2",
		"3": u"3",
		"4": u"4",
		"5": u"5",
		"6": u"6",
		"7": u"7",
		"8": u"8",
		"9": u"9",
		"star": u"*",
		"hash": u"#",
		}
	def __init__(self, ee, callback):
		Detail.__init__(self, ee, callback, 'numpad')
		self.part.signal_callback_add("mouse,move", "*", self.on_mouse_move)
		self.part.signal_callback_add("mouse,up,1", "*", self.on_mouse_up)
		self.mouse_down = False
		self.x_pos, self.y_pos, self.start_y_pos = 0, 0, 0
		self.lowercase = True
		self.digit = None
		self.delta = 0
		self.field = u''
		self.char = None
	def yes(self):
		self.callback(self.field)
		self.delete()
		return True
	def on_mouse_down(self, edje_obj, emission, source):
		if not source in ('yes', 'no', 'maybe', 'back', 'empty', 'background', ):
			self.digit = self.digits[source]
			self.char = self.digit[0]
			self.x_pos, self.y_pos = self.part.evas.pointer_canvas_xy
			self.start_y_pos = self.y_pos
			self.lowercase = True
			self.delta = 0
			self.mouse_down = True
			self.set_char(self.char)
			self.x_pos, self.y_pos = self.part.evas.pointer_canvas_xy
	def on_mouse_up(self, edje_obj, emission, source):
		if source in ('yes', 'no', 'maybe', ):
			getattr(self, source)()
		elif source in ('back', 'empty', 'background', ):
			if source == 'back':
				if len(self.field) > 0:
					self.field = self.field[:-1]
					self.set_line(self.field)
				else:
					global pypwrd_hook
					pypwrd_hook.vibrate(40, reply_handler=ign, error_handler=ign, )
		elif self.mouse_down:
			self.field += self.char
			self.mouse_down = False
			self.x_pos, self.y_pos = 0, 0
			self.delta = 0
			self.char = None
			self.set_line(self.field)
			self.set_char("")
	def on_mouse_move(self, edje_obj, emission, source):
		if self.mouse_down and not source in ('yes', 'no', 'maybe', 'back', 'empty', 'background', ):
			x_pos, y_pos = self.part.evas.pointer_canvas_xy
			delta = abs(self.x_pos - x_pos) + abs(self.y_pos - y_pos)
			if delta > 10:
				self.delta += delta
				if self.lowercase and y_pos + 60 < self.start_y_pos:
					self.delta -= 60
					self.lowercase = False
				if self.lowercase:
					char = self.digit[(self.delta / 120) % len(self.digit)]
				else:
					char = self.digit[(self.delta / 120) % len(self.digit)].upper()
				if self.char != char:
					self.char = char
					self.set_char(char)
					global pypwrd_hook
					pypwrd_hook.vibrate(40, reply_handler=ign, error_handler=ign, )
				self.x_pos, self.y_pos = x_pos, y_pos
	def set_char(self, char):
		self.part.part_text_set('char', char)
	def set_line(self, line):
		self.part.part_text_set('line', line)

class Alphapad(Numpad):
	digits = {
		"0": u"+=<>$%&0",
		"1": u".,-?!@:;()/1",
		"2": u"abc2",
		"3": u"def3",
		"4": u"ghi4",
		"5": u"jkl5",
		"6": u"mno6",
		"7": u"pqrs7",
		"8": u"tuv8",
		"9": u"wxyz9",
		"star": u"*",
		"hash": u" #",
		}
	def __init__(self, ee, thing):
		Numpad.__init__(self, ee, thing)

class Thing(object):
	def __init__(self, ee, thingfeed, type, screenpos=1, active=True, ):
		self.thingfeed = thingfeed
		self.ee = ee
		self.part = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group='thing')
		self.set_screenpos(screenpos, active)
		self.cury = self.setpointy
		self.curx = - self.part.rect.w # TODO: where to get the screenwidth
		self.part.move(self.curx, self.cury)
		self.set_icon(type)
		self.part.show()
	def set_text(self, from_, title, subject):
		self.part.part_text_set('text', u'<p>%s</p><h1>%s</h1><p>%s</p>'% (from_, title, subject))
	def set_icon(self, type):
		self.icon = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group=type, )
		if not self.icon:
			self.icon = self.ee.evas.Image(file="/usr/share/pyneog/media/default/%s.png"% type)
			w, h = self.icon.image_size
			self.icon.size = w, h,
			self.icon.fill = 0, 0, w, h,
			#self.icon.center = 
			#self.icon.show()
		self.part.part_swallow('icon', self.icon)
	def set_screenpos(self, screenpos, active, ):
		self.active = active
		self.setpointx = 0
		if not active:
			self.part.color = (96, 96, 96, 96, )
		else:
			self.part.color = (255, 255, 255, 255, )
		self.setpointy = self.part.geometry[3] * screenpos
	def animate(self):
		if self.cury != self.setpointy \
		or self.curx != self.setpointx:
			dx = (self.setpointx - self.curx) / 3
			if dx < 3 and dx > -3:
				self.curx = self.setpointx
			#elif dx > 24: self.curx += 24
			#elif dx < -24: self.curx += -24
			else:
				self.curx += dx
			dy = (self.setpointy - self.cury) / 3
			if dy < 3 and dy > -3:
				self.cury = self.setpointy
			#elif dy > 24: self.cury += 24
			#elif dy < -24: self.cury += -24
			else:
				self.cury += dy
			self.part.move(self.curx, self.cury)
			return True
		return False
	def yes(self):
		return self.thingfeed.yes(self)
	def no(self):
		return self.thingfeed.no(self)
	def maybe(self):
		return self.thingfeed.maybe(self)
	def __del__(self):
		#self.part.part_unswallow(self.icon)
		#self.part.hide()
		self.part.delete()
		self.icon.delete()
		del self.icon
		del self.part

class ThingFeeds(object):
	bus = None
	background = None
	thingfeeds = []
	@classmethod
	def init(clazz, ee, *thingfeeds):
		clazz.bus = SystemBus(mainloop=DBusEcoreMainLoop())
		clazz.background = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group='background')
		clazz.background.size = ee.evas.size
		clazz.background.show()
		ee.data['thingfeeds'] = clazz
		Things.init(ee)
		for thingfeed in thingfeeds:
			clazz.add(thingfeed(ee, clazz, Things))
	@classmethod
	def add(clazz, thingfeed):
		clazz.thingfeeds.append(thingfeed)

class ThingFeed(object):
	def __init__(self, ee, thingfeeds, things):
		self.ee = ee
		self.thingfeeds = thingfeeds
		self.things = things
	def yes(self, thing):
		return True
	def no(self, thing):
		return True
	def maybe(self, thing):
		return True

class NoappleFeed(ThingFeed):
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		ecore.timer_add(2, self.new)
	def new(self):
		self.thing = Thing(self.ee, self, "noapple")
		self.thing.set_text(datetime.now().isoformat(' ')[:19], u'Dies ist kein iphon', u'Bitte benutze keine Drg-Operationen.', )
		self.things.new(self.thing)
		return False
	def text(self, f):
		self.thing.set_text(datetime.now().isoformat(' ')[:19], u'Dies ist kein iphon', f, )
	def yes(self, thing):
		global detail_view
		detail_view = Alphapad(self.ee, self.text)
		return False
	def no(self, thing):
		ecore.timer_add(45, self.new)
		return True
	def maybe(self, thing):
		ecore.timer_add(4, self.new)
		return True

class EntryFeed(ThingFeed):
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		ecore.timer_add(3, self.init_dbus)
	def init_dbus(self):
		print 'EntryFeed init_dbus'
		try:
			ent_obj = self.thingfeeds.bus.get_object('org.mobile.ent', '/org/mobile/ent/RemoteObject')
			ent_name = 'org.mobile.ent.RemoteInterface'
			for fkt in (self.new_entry, ):
				ent_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=ent_name)
			self.ent_interface = Interface(ent_obj, ent_name)
			print 'EntryFeed success'
			return False
		except Exception, e:
			print 'EntryFeed', e
			return True
	def new_entry_content(self, content):
		content = dedbusmap(content)
		print 'new_entry_content', content
		thing = Thing(self.ee, self, content.get('subarea', "empty"))
		thing.content = content
		thing.set_text(
			content.get('created', ''),
			content.get('title', '') or content.get('contact', ''),
			content.get('subject', '') or content.get('text', ''),
			)
		self.things.new(thing)
	def answer(self, decision):
		self.thing.yes()
	def new_entry(self, instance, id, ):
		print 'new_entry', instance, id
		obj = self.ent_interface.get(int(id), reply_handler=self.new_entry_content, error_handler=ign)
	def yes(self, thing):
		global detail_view
		detail_view = TextDetail(self.ee,
			u'<p>%s</p><h1>%s</h1><p>%s</p><p>%s</p><p>%s</p>'% (
				thing.content.get('created', ''),
				thing.content.get('title', ''),
				thing.content.get('contact', ''),
				thing.content.get('subject', ''),
				thing.content.get('text', ''),
				),
			self.answer)
		return False

class PhoneFeed(ThingFeed):
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		self.thing = Thing(self.ee, self, "phone")
		self.things.new(self.thing)
		self.pin_state = 'UNBEKANNT'
		self.network_stat = 0 # not registered
		self.rssi = 0
		self.oper = ''
		self.lac = '0000'
		self.ci = '0000'
		self.col_number = ''
		self.phone_activity_status = 2 # unknown
		self.dialing = False
		self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', self.pin_state, )
		ecore.timer_add(3, self.init_dbus)
	def init_dbus(self):
		print 'PhoneFeed init_dbus'
		try:
			gsm_obj = self.thingfeeds.bus.get_object('org.mobile.gsm', '/org/mobile/gsm/RemoteObject')
			gsm_name = 'org.mobile.gsm.RemoteInterface'
			for fkt in (self.modem_status, self.sim_status, self.network_status, self.error, ):
				gsm_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=gsm_name)
			self.gsm_interface = Interface(gsm_obj, gsm_name)
			self.gsm_interface.get_modem_status(reply_handler=self.modem_status, error_handler=ign, )
			self.gsm_interface.get_sim_status(reply_handler=self.sim_status, error_handler=ign, )
			self.gsm_interface.get_network_status(reply_handler=self.network_status, error_handler=ign, )
			print 'PhoneFeed success'
			return False
		except Exception, e:
			print 'PhoneFeed', e
			return True
	def error(self, list):
		print 'error', map(str, list)
	def modem_status(self, newmap):
		newmap = dedbusmap(newmap)
		print 'modem_status', newmap
	def sim_status(self, newmap):
		newmap = dedbusmap(newmap)
		print 'sim_status', newmap
		self.pin_state = newmap.get('pin_state', self.pin_state)
		if self.pin_state == 'READY':
			print 'sim unlocked'
			self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Sim entsperrt', )
		elif self.pin_state == 'SIM PIN':
			print 'pin required'
			self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', self.pin_state, )
		else:
			self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', self.pin_state, )
	def network_status(self, newmap):
		newmap = dedbusmap(newmap)
		print 'network_status', newmap
		if self.pin_state == 'READY':
			self.network_stat = int(newmap.get('stat', self.network_stat))
			if self.network_stat in (1, 5, ):
				roamaing = self.network_stat == 5
				self.rssi = int(newmap.get('rssi', self.rssi))
				self.oper = newmap.get('oper', self.oper)
				self.lac = newmap.get('lac', self.lac)
				self.ci = newmap.get('ci', self.ci)
				self.col_number = newmap.get('col_number', self.col_number)
				self.phone_activity_status = int(newmap.get('phone_activity_status', self.phone_activity_status))
				if self.phone_activity_status == 0: # ready
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Bereit: Signal: %d Zelle: %s:%s Betreiber: %s %s'% (self.rssi, self.lac, self.ci, self.oper, roamaing and 'Fremdnetz' or '', ), )
				elif self.phone_activity_status == 3: # ringing
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Anruf %s'% self.col_number, )
					pypwrd_hook.vibrate(900, reply_handler=ign, error_handler=ign, )
				elif self.phone_activity_status == 4: # call in progress
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Gesprch', )
				elif self.phone_activity_status == 99: # invented :/
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Besetzt', )
				else:
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Fehler', )
			else:
				self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Registriere im Netzwerk', )
				self.gsm_interface.register(0, reply_handler=ign, error_handler=ign, )
	def dial(self, number):
		self.col_number = number
		self.gsm_interface.dial(number, reply_handler=ign, error_handler=ign)
		self.dialing = True
		system('alsactl -f /etc/gsmhandset.state restore')
		self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', u'Anruf ttigen...', )
		self.gsm_interface.get_network_status(reply_handler=ign, error_handler=ign, )
	def send_pin(self, pin):
		self.gsm_interface.pin(pin, reply_handler=ign, error_handler=ign, )
		self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Pin gesendet', )
	def yes(self, thing):
		global detail_view
		if self.pin_state == 'READY':
			if self.network_stat in (1, 5, ):
				if self.phone_activity_status == 3: # ringing
					self.gsm_interface.answer(reply_handler=ign, error_handler=ign, )
					system('alsactl -f /etc/gsmhandset.state restore')
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Anruf beantworten...', )
					self.gsm_interface.get_network_status(reply_handler=ign, error_handler=ign, )
				elif self.phone_activity_status == 0: # ready
					detail_view = Numpad(self.ee, self.dial)
				elif self.phone_activity_status == 4: # call in progress
					self.gsm_interface.hangup(reply_handler=ign, error_handler=ign, )
					system('alsactl restore')
					self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Anruf beenden...', )
					self.gsm_interface.get_network_status(reply_handler=ign, error_handler=ign, )
					self.dialing = False
		elif self.pin_state == 'SIM PIN':
			detail_view = Numpad(self.ee, self.send_pin)
		return False
	def no(self, thing):
		if self.dialing:
			self.gsm_interface.hangup(reply_handler=ign, error_handler=ign, )
			self.thing.set_text(datetime.now().isoformat(' ')[:19], 'Telefon Status', 'Anruf beenden...', )
			self.gsm_interface.get_network_status(reply_handler=ign, error_handler=ign, )
			self.dialing = False
		return False
	def maybe(self, thing):
		return False

class NetworkFeed(ThingFeed):
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		self.thing = Thing(self.ee, self, 'network')
		self.things.new(self.thing)
		self.thing.set_text(
			datetime.now().isoformat(' ')[:19],
			'Netzwerk',
			'',
			)
		ecore.timer_add(3, self.init_dbus)
	def init_dbus(self):
		print 'NetworkFeed init_dbus'
		try:
			ppp_obj = self.thingfeeds.bus.get_object('org.mobile.ppp', '/org/mobile/ppp/RemoteObject')
			ppp_name = 'org.mobile.ppp.RemoteInterface'
			for fkt in (self.status, ):
				ppp_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=ppp_name)
			self.ppp_interface = Interface(ppp_obj, ppp_name)
			self.ppp_interface.get_status(reply_handler=self.status, error_handler=ign, )
			print 'NetworkFeed success'
			return False
		except Exception, e:
			print 'NetworkFeed', e
			return True
	def status(self, status):
		status = dedbusmap(status)
		print 'status', status
		status = status['device']
		if status.startswith('usb'):
			mode = 'network.usb'
		elif status.startswith('eth'):
			mode = 'network.wlan'
		elif status.startswith('pan'): # TODO
			mode = 'network.bt'
		else:
			mode = 'network'
		icon = edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group=mode, )
		if icon:
			self.thing.part.part_swallow('icon', icon)
		self.thing.set_text(
			datetime.now().isoformat(' ')[:19],
			u'Netzwerk',
			u'Benutztes Gert: %s'% status,
			)
		if not self.things.is_visible(self.thing):
			self.things.new(self.thing)
	def yes(self, thing):
		self.ppp_interface.activate(True, reply_handler=self.status, error_handler=ign, )
		return True
	def no(self, thing):
		self.ppp_interface.activate(False, reply_handler=self.status, error_handler=ign, )
		return True

class LocationFeed(ThingFeed):
	# see http://www.figator.com/search/top50+nrw/::rd
	# and http://www.qlandkarte.org/index.php?option=com_content&view=article&id=3&Itemid=4
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		self.thing = Thing(self.ee, self, 'location')
		self.things.new(self.thing)
		self.state = dict(
			fix=0,
			gglfix=False,
			lat=-1.0,
			lon=-1.0,
			altitude=0.0,
			)
		self.update()
		self.ggl_inited = False
		self.gps_inited = False
		ecore.timer_add(3, self.init_dbus)
	def init_dbus(self):
		print 'LocationFeed init_dbus'
		try:
			if not self.gps_inited:
				gps_obj = self.thingfeeds.bus.get_object('org.mobile.gps', '/org/mobile/gps/RemoteObject')
				gps_name = 'org.mobile.gps.RemoteInterface'
				for fkt in (self.position, self.satellites, self.accuracy, ):
					gps_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=gps_name)
				self.gps_interface = Interface(gps_obj, gps_name)
				self.gps_interface.get_position(reply_handler=self.position, error_handler=ign, )
				self.gps_inited = True
		except Exception, e:
			print 'LocationFeed gps', e
		try:
			if not self.ggl_inited:
				ggl_obj = self.thingfeeds.bus.get_object('org.mobile.ggl', '/org/mobile/ggl/RemoteObject')
				ggl_name = 'org.mobile.ggl.RemoteInterface'
				for fkt in (self.location, ):
					ggl_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=ggl_name)
				self.ggl_interface = Interface(ggl_obj, ggl_name)
				self.ggl_interface.get_location(reply_handler=self.location, error_handler=ign, )
				self.ggl_inited = True
			print 'LocationFeed success'
		except Exception, e:
			print 'LocationFeed ggl', e
		return not self.ggl_inited or not self.gps_inited
	def location(self, content):
		content = dedbusmap(content)
		#print 'location', content
		if int(content['gglfix']):
			self.state = dict(self.state, **content)
			self.update()
	def position(self, content):
		content = dedbusmap(content)
		#print 'position', content
		fix = int(content.get('fix', 0))
		if fix:
			self.state = dict(self.state, **content)
			self.update()
	def satellites(self, content):
		content = dedbusmap(content)
		#print 'satellites', content
		self.state = dict(self.state, **content)
		self.update()
	def accuracy(self, content):
		content = dedbusmap(content)
		#print 'accuracy', content
		self.state = dict(self.state, **content)
		self.update()
	def update(self):
		self.thing.set_text(
			datetime.now().isoformat(' ')[:19],
			'Position',
			'%s: %f/%f %.2fm %fkm/h %f'% (
				(bool(self.state['fix']) or bool(self.state['gglfix'])) and 'Fix' or 'Kein Fix',
				float(self.state.get('latitude', 0)),
				float(self.state.get('longitude', 0)),
				float(self.state.get('altitude', 0)),
				float(self.state.get('kph', 0)),
				float(self.state.get('course', 0)),
				),
			)
		if not self.things.is_visible(self.thing):
			self.things.new(self.thing)
	def yes(self, thing):
		self.gps_interface.get_position(reply_handler=self.position, error_handler=ign, )
		self.ggl_interface.get_location(reply_handler=self.location, error_handler=ign, )
		return False

class PowerFeed(ThingFeed):
	def __init__(self, ee, thingfeeds, things):
		ThingFeed.__init__(self, ee, thingfeeds, things)
		self.thing = Thing(self.ee, self, 'power')
		self.things.new(self.thing)
		self.thing.set_text(
			datetime.now().isoformat(' ')[:19],
			'Batterie',
			'',
			)
		ecore.timer_add(3, self.init_dbus)
	def init_dbus(self):
		print 'PowerFeed init_dbus'
		try:
			pwr_obj = self.thingfeeds.bus.get_object('org.mobile.pwr', '/org/mobile/pwr/RemoteObject')
			pwr_name = 'org.mobile.pwr.RemoteInterface'
			for fkt in (self.status, ):
				pwr_obj.connect_to_signal(fkt.__name__, fkt, dbus_interface=pwr_name)
			self.pwr_interface = Interface(pwr_obj, pwr_name)
			global pypwrd_hook
			pypwrd_hook = self.pwr_interface
			print 'PowerFeed get_status'
			self.pwr_interface.get_status(reply_handler=self.status, error_handler=ign, )
			print 'PowerFeed success'
			return False
		except Exception, e:
			print 'PowerFeed', e
			return True
	def status(self, content, ):
		content = dedbusmap(content)
		#print 'status', content
		self.thing.content = content
		self.thing.set_text(
			datetime.now().isoformat(' ')[:19],
			'Batterie',
			'%s: %sV %sA'% (
				content.get('chgmode', 'unknown'),
				content.get('battvolt', 0),
				content.get('chgcur', 0),
				),
			)
		if not self.things.is_visible(self.thing):
			self.things.new(self.thing)

try:
	edje.frametime_set(0.08)
	#ee = ecore.evas.XRenderX11(w=480, h=640)
	ee = ecore.evas.SoftwareX11_16(w=480, h=640)
	#ee = ecore.evas.SoftwareX11(w=480, h=640)
	ee.fullscreen = 1
	ee.name_class = ('pyneog', 'ebrowser')
	ee.title = 'pyneog'
	ThingFeeds.init(ee,
		NoappleFeed,
		PhoneFeed,
		LocationFeed,
		NetworkFeed,
		PowerFeed,
		EntryFeed,
		)
	ee.cursor_set(edje.Edje(ee.evas, file='/usr/share/pyneog/media/default/ebrowser.edj', group='cursor'), 0x7fffffff, 50, 40)
	ee.show()
		#self.part.part_text_set('up', text)
	ecore.main_loop_begin()
finally:
	try: ecore.event.shutdown()
	except: pass
#import traceback
#traceback.print_exc()
# vim:tw=0:nowrap
